# MRI_Reconstruction
This is the code for our EE367 final project: 
**Comparison of Randomly Undersampled Magnetic Resonance Imaging Reconstruction Methods**


For CRNN, we follow the implementation of the offical code [Here](https://github.com/tinyRattar/CSMRI_0325) for the paper 
**Cascaded Dilated Dense Network with Two-step Data Consistency for MRI Reconstruction** published in NeruIPS 2019. [Here](http://papers.nips.cc/paper/8451-cascaded-dilated-dense-network-with-two-step-data-consistency-for-mri-reconstruction) is the Link for the paper.

# Requirements
- Python==3.8.12
- numpy==1.21.2
- opencv-python==4.5.4.60
- pytorch==1.7.1
- matplotlib==3.4.3
- scipy==1.7.0
- tqdm==4.62.3
- sigpy==0.1.23

# Single image testing
```bash
python test.py --mode ADMM_TVa --us 0.6 --imgpath ./data/Brain_data/vali/2169.jpg --savepath ./img_results/ 
```

# How to Train CRNN
1. Prepare data.
2. Create an Initialization File in `config/`, named like `CONFIGNAME.ini`. You can also make a copy of `default.ini` and edit it.
3. run `python main.py CONFIGNAME`. Notice that `config/` and `.ini` will be added automatically.

More details can be found below.

# Prepare Data
Training data should be put in `./data/datasetName/train/` and validation data in `./data/datasetName/vali/`.

# How to Conifg
## general 
usecude: use `True` for cuda

NeedParallel: use `True` if you want to train with multi gpu devices. We recommend to choose `True` even if only one devices is available.

Device: 1 for use and 0 for not. E.g., you want to use the 2nd and the 3rd gpu devices , you should write `0110` here. (more or less devices is acceptable)

us_rate: undersamling rate

train_path: image loading path for training dataset

vali_path: image loading path for validation dataset

## log
SaveEpoch: The result will be logged and saved per SaveEpoch epoches.

MaxSaved: Only last `MaxSaved` weights will be reversed. Earlier ones will be removed automatically.
